/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/*****************************************************************************/
/** \file adc.h
**
** History:
** 
*****************************************************************************/
#ifndef __ADC_H_
#define __ADC_H_

#ifdef __cplusplus
extern "C"
{
#endif

/*****************************************************************************/
/* Include files */
/*****************************************************************************/
#include "common.h"
/*****************************************************************************/
/* Global pre-processor symbols/macros ('#define') */
/*****************************************************************************/

/*----------------------------------------------------------------------------
 **ADC תģʽ
-----------------------------------------------------------------------------*/
#define 	ADC_MODE_HIGH		(0x00UL)						/*תģʽ*/
#define 	ADC_MODE_LOW		(0x03UL<<ADC_CON_ADMODE10_Pos)	/*͵ģʽ*/

#define 	ADC_CONVERT_SINGLE		(0x00UL)						/*ģʽ*/
#define 	ADC_CONVERT_CONTINUOUS		(0x01UL<<ADC_CON_ADCMS_Pos)	/*ģʽ*/

#define 	ADC_SWITCH_HARDWARE	(0x00UL)						/*ӲԶлģʽ*/
#define 	ADC_SWITCH_SOFTWARE	(0x1UL<<ADC_CON_ADCSWCHE_Pos)	/*лģʽ*/

/*----------------------------------------------------------------------------
 **ADC ʱӷƵ
-----------------------------------------------------------------------------*/
#define 	ADC_CLK_DIV_1		(0x00UL)			/*ADC ʱӷƵΪ 1*/
#define 	ADC_CLK_DIV_2		(0x01UL)			/*ADC ʱӷƵΪ 2*/
#define 	ADC_CLK_DIV_4		(0x02UL)			/*ADC ʱӷƵΪ 4*/
#define 	ADC_CLK_DIV_8		(0x03UL)			/*ADC ʱӷƵΪ 8*/
#define 	ADC_CLK_DIV_16		(0x04UL)			/*ADC ʱӷƵΪ 16*/
#define 	ADC_CLK_DIV_32		(0x05UL)			/*ADC ʱӷƵΪ 32*/
#define 	ADC_CLK_DIV_64		(0x06UL)			/*ADC ʱӷƵΪ 64*/
#define 	ADC_CLK_DIV_128	(0x07UL)			/*ADC ʱӷƵΪ 128*/

/*----------------------------------------------------------------------------
 **ADC 硢ŵʱ
-----------------------------------------------------------------------------*/
#define 	ADC_CG_2			(0x02UL)				/* 2*ADCCLK*/
#define 	ADC_CG_3			(0x03UL)				/* 3*ADCCLK*/
#define 	ADC_CG_4			(0x04UL)				/* 4*ADCCLK*/
#define 	ADC_CG_5			(0x05UL)				/* 5*ADCCLK*/
#define 	ADC_CG_6			(0x06UL)				/* 6*ADCCLK*/
#define 	ADC_CG_7			(0x07UL)				/* 7*ADCCLK*/
#define 	ADC_CG_8			(0x08UL)				/* 8*ADCCLK*/
#define 	ADC_CG_9			(0x09UL)				/* 9*ADCCLK*/
#define 	ADC_CG_10			(0x0AUL)				/* 10*ADCCLK*/
#define 	ADC_CG_11			(0x0BUL)				/* 11*ADCCLK*/
#define 	ADC_CG_12			(0x0CUL)				/* 12*ADCCLK*/
#define 	ADC_CG_13			(0x0DUL)				/* 13*ADCCLK*/
#define 	ADC_CG_14			(0x0EUL)				/* 14*ADCCLK*/
#define 	ADC_CG_15			(0x0FUL)				/* 15*ADCCLK*/

/*----------------------------------------------------------------------------
 **ADC οԴ
-----------------------------------------------------------------------------*/
#define		ADC_VREFP_VDD		(0x00UL)						/*ѡVDDΪ˲ο*/
#define     ADC_VREFP_BG		(0x02UL<<ADC_CON_ADCVS_Pos)	/*ѡBG1.45VΪ˲ο*/

/*---------------------------------------------------------------------------*/
#define		ADC_VREFP_AVREFP	(0x01UL<<ADC_CON_ADCVS_Pos)	/*ѡVREF(ADCLDO )Ϊ˲ο	*/

/*----------------------------------------------------------------------------
 **ADC ڲԴѡ
-----------------------------------------------------------------------------*/
//#define		ADC_TG_INTNEL_ADCA				(0x0UL | ADC_HWTG_ADCINTTGEN_Msk)		/*ڲADCA*/	
#define		ADC_TG_INTNEL_ADC				((0x1UL<<ADC_HWTG_ADCINTTGSS_Pos)| ADC_HWTG_ADCINTTGEN_Msk)	/*ڲADC*/		
#define		ADC_TG_INTNEL_ACMP0			((0x2UL<<ADC_HWTG_ADCINTTGSS_Pos)| ADC_HWTG_ADCINTTGEN_Msk)	/*ڲACMP0¼*/					
#define		ADC_TG_INTNEL_ACMP1			((0x3UL<<ADC_HWTG_ADCINTTGSS_Pos)| ADC_HWTG_ADCINTTGEN_Msk)	/*ڲACMP1¼*/	
#define		ADC_TG_INTNEL_TMR0				((0x4UL<<ADC_HWTG_ADCINTTGSS_Pos)| ADC_HWTG_ADCINTTGEN_Msk)	/*ڲTMR0ʹжϴ*/			
#define		ADC_TG_INTNEL_TMR1				((0x5UL<<ADC_HWTG_ADCINTTGSS_Pos)| ADC_HWTG_ADCINTTGEN_Msk)	/*ڲTMR1ʹжϴ*/	
//#define		ADC_TG_INTNEL_TMR2				((0x6UL<<ADC_HWTG_ADCINTTGSS_Pos)| ADC_HWTG_ADCINTTGEN_Msk)	/*ڲTMR2ʹжϴ*/			
//#define		ADC_TG_INTNEL_TMR3				((0x7UL<<ADC_HWTG_ADCINTTGSS_Pos)| ADC_HWTG_ADCINTTGEN_Msk)	/*ڲTMR3ʹжϴ*/	

/*----------------------------------------------------------------------------
 **ADC EPWMԴѡ
-----------------------------------------------------------------------------*/
#define		ADC_TG_EPWM_CMP0				(0x01UL<<ADC_HWTG_ADCPTG0EN_Pos)	/*EPWMȽ0*/
#define		ADC_TG_EPWM_CMP1				(0x01UL<<ADC_HWTG_ADCPTG1EN_Pos)	/*EPWMȽ1*/

#define		ADC_TG_EPWM0_RISING			(0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)	/*EPWM0شж*/
#define		ADC_TG_EPWM0_FALLING			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)|(0x2<<ADC_HWTG_ADCEPWMTPS_Pos))	/*EPWM0½شж*/		
#define		ADC_TG_EPWM0_PERIOD			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)|(0x1<<ADC_HWTG_ADCEPWMTPS_Pos))	/*EPWM0ڵ㴥ж*/	
#define		ADC_TG_EPWM0_ZERO				((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)|(0x3<<ADC_HWTG_ADCEPWMTPS_Pos))	/*EPWM0㴥ж*/
#define		ADC_TG_EPWM1_RISING			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x1<<ADC_HWTG_ADCEPWMTSS_Pos))
#define		ADC_TG_EPWM1_FALLING			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x1<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x2<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM1_PERIOD			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x1<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x1<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM1_ZERO				((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x1<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x3<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM2_RISING			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x2<<ADC_HWTG_ADCEPWMTSS_Pos))
#define		ADC_TG_EPWM2_FALLING			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x2<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x2<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM2_PERIOD			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x2<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x1<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM2_ZERO				((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x2<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x3<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM3_RISING			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x3<<ADC_HWTG_ADCEPWMTSS_Pos))
#define		ADC_TG_EPWM3_FALLING			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x3<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x2<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM3_PERIOD			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x3<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x1<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM3_ZERO				((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x3<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x3<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM4_RISING			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x4<<ADC_HWTG_ADCEPWMTSS_Pos))
#define		ADC_TG_EPWM4_FALLING			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x4<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x2<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM4_PERIOD			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x4<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x1<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM4_ZERO				((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x4<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x3<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM5_RISING			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x5<<ADC_HWTG_ADCEPWMTSS_Pos))
#define		ADC_TG_EPWM5_FALLING			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x5<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x2<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM5_PERIOD			((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x5<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x1<<ADC_HWTG_ADCEPWMTPS_Pos))
#define		ADC_TG_EPWM5_ZERO				((0x1UL<<ADC_HWTG_ADCEPWMTEN_Pos)| (0x5<<ADC_HWTG_ADCEPWMTSS_Pos)|(0x3<<ADC_HWTG_ADCEPWMTPS_Pos))

/*----------------------------------------------------------------------------
 **ADC ͨ
-----------------------------------------------------------------------------*/
#define		ADC_CH_0					(0x0UL)			//PGA0				
#define		ADC_CH_1					(0x1UL)			//PGA0	
#define		ADC_CH_2					(0x2UL)			//A1O			
#define		ADC_CH_3					(0x3UL)			//A2O			
#define		ADC_CH_4					(0x4UL)			//P20		
#define		ADC_CH_5					(0x5UL)			//P21			
#define		ADC_CH_6					(0x6UL)			//P22	
#define		ADC_CH_7					(0x7UL)			//P23			
#define		ADC_CH_8					(0x8UL)			//P00
#define		ADC_CH_9					(0x9UL)			//P01		
#define		ADC_CH_10					(0xAUL)			//P02			
#define		ADC_CH_11					(0xBUL)			//P03	
#define		ADC_CH_12					(0xCUL)			//P04			
#define		ADC_CH_13					(0xDUL)			//P05			
#define		ADC_CH_14					(0xEUL)			//P24		
#define		ADC_CH_15					(0xFUL)			//P25			
#define		ADC_CH_16					(0x10UL)			//P26	
#define		ADC_CH_17					(0x11UL)			//P27			
#define		ADC_CH_18					(0x12UL)			//P16			
#define		ADC_CH_20					(0x14UL)			//VDD	
#define		ADC_CH_21					(0x15UL)			//GND			
#define		ADC_CH_22					(0x16UL)	   //BG2AD		
#define		ADC_CH_23					(0x17UL)			//Internal Channel


#define		ADC_CH_0_MSK				(0x1UL)			
#define		ADC_CH_1_MSK				(0x2UL)	
#define		ADC_CH_2_MSK				(0x4UL)			
#define		ADC_CH_3_MSK				(0x8UL)			
#define		ADC_CH_4_MSK				(0x10UL)		
#define		ADC_CH_5_MSK				(0x20UL)			
#define		ADC_CH_6_MSK				(0x40UL)	
#define		ADC_CH_7_MSK				(0x80UL)			
#define		ADC_CH_8_MSK				(0x100UL)			
#define		ADC_CH_9_MSK				(0x200UL)		
#define		ADC_CH_10_MSK				(0x400UL)			
#define		ADC_CH_11_MSK				(0x800UL)	
#define		ADC_CH_12_MSK				(0x1000UL)			
#define		ADC_CH_13_MSK				(0x2000UL)			
#define		ADC_CH_14_MSK				(0x4000UL)		
#define		ADC_CH_15_MSK				(0x8000UL)			
#define		ADC_CH_16_MSK				(0x10000UL)	
#define		ADC_CH_17_MSK				(0x20000UL)			
#define		ADC_CH_18_MSK				(0x40000UL)			

#define		ADC_CH_20_MSK				(0x100000UL)			
#define		ADC_CH_21_MSK				(0x200000UL)	
#define		ADC_CH_22_MSK				(0x400000UL)			
#define		ADC_CH_23_MSK				(0x800000UL)			

/*----------------------------------------------------------------------------
 **ADC  AN22ѡ
-----------------------------------------------------------------------------*/
#define    ADC_AN22_SEL_TS				(0x0UL)			/*ڲ¶ȴ*/
#define    ADC_AN22_SEL_BG				(0x1UL)			/*ڲBG 1.45V*/

/*----------------------------------------------------------------------------
 **ADC  AN23ѡ
-----------------------------------------------------------------------------*/
#define    ADC_AN23_SEL_DAC     	(0x4UL)			/*DAC*/


/*----------------------------------------------------------------------------
 **ADC1   Ƚ
-----------------------------------------------------------------------------*/
#define		ADC_CMP_LESS_THAN_RESULT		(0x00UL)		/*ADC <Ԥֵ*/
#define		ADC_CMP_NOT_LESS_THAN_RESULT	(0x01UL<<ADC_CMP_ADCCMPCOND_Pos)		/*ADC >=Ԥֵ*/

#define		ADC_CMP0						(0x00UL)		/*ADCȽ0*/
#define		ADC_CMP1						(0x01UL)		/*ADCȽ1*/
	

/*----------------------------------------------------------------------------
 **ADC1   д
-----------------------------------------------------------------------------*/
#define		ADC_LOCK_WRITE_KEY		(0x55UL)

/*****************************************************************************
 ** \brief	ADC_IS_BUSY
 **			ȡADCת/б־λ
 ** \param [in] none
 ** \return  1æ   0/ת
 ** \note	 
*****************************************************************************/
#define	ADC_IS_BUSY()		((ADC->CON2&ADC_CON2_ADCST_Msk)? 1:0)


/*****************************************************************************
 ** \brief	ADC_Go
 **			ADC1ת
 ** \param [in] none
 ** \return  none
 ** \note	 
*****************************************************************************/
__STATIC_INLINE	void ADC_Go(void)
{
	ADC->LOCK = ADC_LOCK_WRITE_KEY;
	ADC->CON2 |= ADC_CON2_ADCST_Msk;
	ADC->LOCK = 0x00;
}

							
/*****************************************************************************/
/* Global type definitions ('typedef') */
/*****************************************************************************/


/*****************************************************************************/
/* Global variable declarations ('extern', definition in C source) */
/*****************************************************************************/


/*****************************************************************************/
/* Global function prototypes ('extern', definition in C source) */
/*****************************************************************************/

/*****************************************************************************
 ** \brief	ADC_ConfigRunMode
 **			ADCģʽ
 ** \param [in] RunMode: (1)ADC_MODE_HIGH
 **						 (2)ADC_MODE_LOW
 **				ConvertMode:(1)ADC_CONVERT_SINGLE			
 **							(2)ADC_CONVERT_CONTINUOUS				
 **				ClkDiv :(1)ADC_CLK_DIV_1
 **						(2)ADC_CLK_DIV_2
 **						(3)ADC_CLK_DIV_4
 **						(4)ADC_CLK_DIV_8
 **						(5)ADC_CLK_DIV_16
 **						(6)ADC_CLK_DIV_32
 **						(7)ADC_CLK_DIV_64
 **						(8)ADC_CLK_DIV_128
 **				Holdtime: 5~255 		
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_ConfigRunMode(uint32_t RunMode, uint32_t ConvertMode,uint32_t ClkDiv, uint32_t Holdtime);

/*****************************************************************************
 ** \brief	ADC_ConfigChannelSwitchMode
 **			ADCͨлģʽ
 ** \param [in] 	ChSwitch:(1)ADC_SWITCH_HARDWARE	
 **							 (2)ADC_SWITCH_SOFTWARE 
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_ConfigChannelSwitchMode(uint32_t ChSwitch);

/*****************************************************************************
 ** \brief	ADC_EnableCharge
 **			ADC繦
 ** \param [in] ChargeTime:	ADC_CG_2...... ADC_CG_30
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_EnableCharge(uint32_t ChargeTime);
/*****************************************************************************
 ** \brief	ADC_EnableDischarge
 **			ADCŵ繦
 ** \param [in] ChargeTime:	ADC_CG_2...... ADC_CG_30
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_EnableDischarge(uint32_t ChargeTime);

/*****************************************************************************
 ** \brief	ADC_DisableChargeAndDischarge
 **			رADCŵ硢繦
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_DisableChargeAndDischarge(void);

/*****************************************************************************
 ** \brief	ADC_ConfigVREF
 **			ADCĲοԴ
 ** \param [in]  VrefPos:  (1)ADC_VREFP_VDD		ѡVDDΪ˲ο
 **						   (2)ADC_VREFP_BG			ѡBGΪ˲ο
 **						   (3)ADC_VREFP_AVREFP		ѡVREF(ADCLDO )Ϊ˲ο	
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_ConfigVREF(uint32_t VrefPos);


/*****************************************************************************
 ** \brief	ADC_ConfigSampleTime
 **			òʱ
 ** \param [in]  sampletime: 5 ~ 255;
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_ConfigSampleTime(uint32_t sampletime);

/*****************************************************************************
 ** \brief	ADC_EnableSampleWait
 **			ʹADCֲ״̬
 ** \param [in]  none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_EnableSampleWait(void);
/*****************************************************************************
 ** \brief	ADC_DisableSampleWait
 **			رADCֲ״̬
 ** \param [in]  none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_DisableSampleWait(void);

/*****************************************************************************
 ** \brief	ADC_SelSoftwareSwitchChannel
 **			ѡлתͨ
 ** \param [in] Channel: ADC_CH_0 ~ ADC_CH_30
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_SelSoftwareSwitchChannel(uint32_t Channel);

/*****************************************************************************
 ** \brief	ADC_SelAN22Source
 **			   ѡAN22ͨתԴ
 ** \param [in] AN22Sel : (1)ADC_AN22_SEL_TS
 **						  (2)ADC_AN22_SEL_BG
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_SelAN22Source(uint8_t AN22Sel);

/*****************************************************************************
 ** \brief	ADC_EnableScanChannel
 **			ADCתͨ
 ** \param [in] ChannelMask: ADC_CH_0_MSK ~ ADC_CH_30_MSK
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_EnableScanChannel(uint32_t ChannelMask);

/*****************************************************************************
 ** \brief	ADC_AN23Select
 **			AN23ͨѡ
 ** \param [in] AN23Sel : (1)ADC_AN23_SEL_BG
 **						  (2)ADC_AN23_SEL_ADCLDO
 **						  (3)ADC_AN23_SEL_VDDHA
 **						  (4)ADC_AN23_SEL_VDDHCVA
 **						  (5)ADC_AN23_SEL_DAC
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_AN23Select(uint32_t AN23Sel);

/*****************************************************************************
 ** \brief	ADC_DisableScanChannel
 **			رADCתͨ
 ** \param [in] ChannelMask: ADC_CH_0_MSK ~ ADC_CH_30_MSK
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_DisableScanChannel(uint32_t ChannelMask);

/*****************************************************************************
 ** \brief	ADC_GetResult
 **			ȡADCת
 ** \param [in] Channel: ADC1_CH_0 ~ ADC1_CH_30
 ** \return  12 bits Value
 ** \note	
*****************************************************************************/
uint32_t ADC_GetResult(uint32_t Channel);

/*****************************************************************************
 ** \brief	ADC_EnableHardwareTrigger
 **			ӲADCת
 ** \param [in] TriggerSource: (1)ADC_TG_EXT_FALLING
 **							(2)ADC_TG_EXT_RISING
 **							(3)ADC_TG_INTNEL_ADCA
 **							(4)ADC_TG_INTNEL_ADC
 **							(5)ADC_TG_INTNEL_ACMP0
 **							(6)ADC_TG_INTNEL_ACMP1
 **							(7)ADC_TG_INTNEL_TMR0
 **							(8)ADC_TG_INTNEL_TMR1
 **							(9)ADC_TG_EPWM_CMP0
 **							(10)ADC_TG_EPWM_CMP1
 **							(11)ADC_TG_EPWM0_RISING
 **							(12)ADC_TG_EPWM0_FALLING
 **							(13)ADC_TG_EPWM0_PERIOD
 **							(14)ADC_TG_EPWM0_ZERRO
 **							(15)ADC_TG_EPWM1_RISING
 **							(16)ADC_TG_EPWM1_FALLING
 **							(17)ADC_TG_EPWM1_PERIOD
 **							(18)ADC_TG_EPWM1_ZERRO
 **							(19)ADC_TG_EPWM2_RISING
 **							(20)ADC_TG_EPWM2_FALLING
 **							(21)ADC_TG_EPWM2_PERIOD
 **							(22)ADC_TG_EPWM2_ZERRO
 **							(23)ADC_TG_EPWM3_RISING
 **							(24)ADC_TG_EPWM3_FALLING
 **							(25)ADC_TG_EPWM3_PERIOD
 **							(26)ADC_TG_EPWM3_ZERRO
 **							(27)ADC_TG_EPWM4_RISING
 **							(28)ADC_TG_EPWM4_FALLING
 **							(29)ADC_TG_EPWM4_PERIOD
 **							(30)ADC_TG_EPWM4_ZERRO
 **							(31)ADC_TG_EPWM5_RISING
 **							(32)ADC_TG_EPWM5_FALLING
 **							(33)ADC_TG_EPWM5_PERIOD
 **							(34)ADC_TG_EPWM5_ZERRO 
 **							(35)ADC_TG_INTNEL_TMR2
 **							(36)ADC_TG_INTNEL_TMR3	
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_EnableHardwareTrigger(uint32_t TriggerSource);
/*****************************************************************************
 ** \brief	ADC1_DisableHardwareTrigger
 **			رӲADC1ת
 ** \param [in] TriggerSource: (1)ADC_TG_EXT_FALLING
 **							(2)ADC_TG_EXT_RISING
 **							(3)ADC_TG_INTNEL_ADCA
 **							(4)ADC_TG_INTNEL_ADC
 **							(5)ADC_TG_INTNEL_ACMP0
 **							(6)ADC_TG_INTNEL_ACMP1
 **							(7)ADC_TG_INTNEL_TMR0
 **							(8)ADC_TG_INTNEL_TMR1
 **							(9)ADC_TG_EPWM_CMP0
 **							(10)ADC_TG_EPWM_CMP1
 **							(11)ADC_TG_EPWM0_RISING
 **							(12)ADC_TG_EPWM0_FALLING
 **							(13)ADC_TG_EPWM0_PERIOD
 **							(14)ADC_TG_EPWM0_ZERRO
 **							(15)ADC_TG_EPWM1_RISING
 **							(16)ADC_TG_EPWM1_FALLING
 **							(17)ADC_TG_EPWM1_PERIOD
 **							(18)ADC_TG_EPWM1_ZERRO
 **							(19)ADC_TG_EPWM2_RISING
 **							(20)ADC_TG_EPWM2_FALLING
 **							(21)ADC_TG_EPWM2_PERIOD
 **							(22)ADC_TG_EPWM2_ZERRO
 **							(23)ADC_TG_EPWM3_RISING
 **							(24)ADC_TG_EPWM3_FALLING
 **							(25)ADC_TG_EPWM3_PERIOD
 **							(26)ADC_TG_EPWM3_ZERRO
 **							(27)ADC_TG_EPWM4_RISING
 **							(28)ADC_TG_EPWM4_FALLING
 **							(29)ADC_TG_EPWM4_PERIOD
 **							(30)ADC_TG_EPWM4_ZERRO
 **							(31)ADC_TG_EPWM5_RISING
 **							(32)ADC_TG_EPWM5_FALLING
 **							(33)ADC_TG_EPWM5_PERIOD
 **							(34)ADC_TG_EPWM5_ZERRO 
 **							(35)ADC_TG_INTNEL_TMR2
 **							(36)ADC_TG_INTNEL_TMR3	
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_DisableHardwareTrigger(uint32_t TriggerSource);

/*****************************************************************************
 ** \brief	ADC_SetTriggerDelayTime
 **			ADC EPWMʱʱ
 ** \param [in] DelayTime: 0x00~ 0x1ff;
 ** \return  none
 ** \note  Time = (DelayTime+2)*PCLK
*****************************************************************************/
void ADC_SetTriggerDelayTime(uint32_t DelayTime);
/*****************************************************************************
 ** \brief	ADC_EnableEPWMTriggerChannel
 **			ʹ EPWM ADCתͨ
 ** \param [in] ChannelMask: ADC_CH_0_MSK ~ ADC_CH_30_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADC_EnableEPWMTriggerChannel(uint32_t ChannelMask);
/*****************************************************************************
 ** \brief	ADC_DisableEPWMTriggerChannel
 **			ر EPWM ADCתͨ
 ** \param [in] ChannelMask: ADC_CH_0_MSK ~ ADC_CH_30_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADC_DisableEPWMTriggerChannel(uint32_t ChannelMask);

/*****************************************************************************
 ** \brief	ADC_EnableEPWMCmp0TriggerChannel
 **			ʹ EPWM Ƚ0 ADCתͨ
 ** \param [in] ChannelMask: ADC_CH_0_MSK ~ ADC_CH_30_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADC_EnableEPWMCmp0TriggerChannel(uint32_t ChannelMask);
/*****************************************************************************
 ** \brief	ADC_DisableEPWMCmp0TriggerChannel
 **			ر EPWM Ƚ0 ADCתͨ
 ** \param [in] ChannelMask: ADC_CH_0_MSK ~ ADC_CH_30_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADC_DisableEPWMCmp0TriggerChannel(uint32_t ChannelMask);

/*****************************************************************************
 ** \brief	ADC_EnableEPWMCmp1TriggerChannel
 **			ʹ EPWM Ƚ1 ADCתͨ
 ** \param [in] ChannelMask: ADC_CH_0_MSK ~ ADC_CH_30_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADC_EnableEPWMCmp1TriggerChannel(uint32_t ChannelMask);
/*****************************************************************************
 ** \brief	ADC_DisableEPWMCmp1TriggerChannel
 **			ر EPWM Ƚ1 ADCתͨ
 ** \param [in] ChannelMask: ADC_CH_0_MSK ~ ADC_CH_30_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADC_DisableEPWMCmp1TriggerChannel(uint32_t ChannelMask);


/*****************************************************************************
 ** \brief	ADC_EnableCompare
 **			ADCȽϹ
 ** \param [in] Compare : ADC_CMP0 ADC_CMP1
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_EnableCompare(uint8_t ACMPx, uint32_t Compare);
/*****************************************************************************
 ** \brief	ADC_DisableCompare
 **			رADCȽϹ
 ** \param [in] Compare : ADC_CMP0 ADC_CMP1
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_DisableCompare(uint8_t ACMPx);
/*****************************************************************************
 ** \brief	ADC_ConfigCompare
 **			ADCȽϹ
 ** \param [in]  Compare : ADC_CMP0 ADC_CMP1
 **				 CmpMode:(1)ADC_CMP_LESS_THAN_RESULT
 **						 (2)ADC_CMP_NOT_LESS_THAN_RESULT
 **				 CmpCount: 0x00~0xf  ԤȽϴ
 **				 CmpChannel: ADC_CH_0 ~ ADC_CH_30
 **				 CmpData : 12 bit Ƚֵ
 ** \return  none
 ** \note	ڲADCCMPxMCNT+1ֵʱADCȽ¼
*****************************************************************************/
void ADC_ConfigCompare(uint8_t ACMPx, uint32_t CmpMode, uint32_t CmpCount,  
						uint32_t CmpChannel, uint32_t CmpData);

/*****************************************************************************
 ** \brief	ADC_GetCompareResult
 **			ȡADCȽ
 ** \param [in] Compare : ADC_CMP0 ADC_CMP1
 ** \return  1 /0
 ** \note	
*****************************************************************************/
uint32_t ADC_GetCompareResult(uint8_t ACMPx);


/*****************************************************************************
 ** \brief	ADC_Start
 **			ADC
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_Start(void);
/*****************************************************************************
 ** \brief	ADC_Stop
 **			رADC
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_Stop(void);

/*****************************************************************************
 ** \brief	ADC_EnableReset
 **			λADC
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_EnableReset(void);

/*****************************************************************************
 ** \brief	ADC_EnableCompareInt
 **			ADCȽж
 ** \param [in] none
 ** \return  none
 ** \note	ֱֻ֧Ƚ 0 
*****************************************************************************/
void ADC_EnableCompareInt(void);
/*****************************************************************************
 ** \brief	ADC_DisableCompareInt
 **			رADCȽж
 ** \param [in] none
 ** \return  none
 ** \note	ֱֻ֧Ƚ 0 
*****************************************************************************/
void ADC_DisableCompareInt(void);
/*****************************************************************************
 ** \brief	ADC_GetCompareIntFlag
 **			ȡADCȽжʹܲҲжϱ־λ
 ** \param [in] none
 ** \return  1:жʹܲҲж 0ж
 ** \note	ֱֻ֧Ƚ 0 
*****************************************************************************/
uint32_t ADC_GetCompareIntFlag(void);
/*****************************************************************************
 ** \brief	ADC_ClearCompareIntFlag
 **			ADCȽжϱ־λ
 ** \param [in] none
 ** \return  none
 ** \note	ֱֻ֧Ƚ 0 
*****************************************************************************/
void ADC_ClearCompareIntFlag(void);

/*****************************************************************************
 ** \brief	ADC_EnableChannelInt
 **			ADCͨnж
 ** \param [in]ChannelMask: ADC_CH_0_MSK ~ ADC_CH_30_MSK
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_EnableChannelInt(uint32_t ChannelMask);
/*****************************************************************************
 ** \brief	ADC_DisableChannelInt
 **			رADCͨnж
 ** \param [in] ChannelMask: ADC_CH_0_MSK ~ ADC_CH_30_MSK
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_DisableChannelInt(uint32_t ChannelMask);
/*****************************************************************************
 ** \brief	ADC_GetChannelIntFlag
 **			ȡADCͨnжʹܲҲжϱ־λ
 ** \param [in] Channel:ADC_CH_0 ~ ADC_CH_30
 ** \return  1:жʹܲҲж 0ж
 ** \note	
*****************************************************************************/
uint32_t ADC_GetChannelIntFlag(uint32_t Channel);
/*****************************************************************************
 ** \brief	ADC_ClearChannelIntFlag
 **			ADCͨnжϱ־λ
 ** \param [in] Channel:ADC_CH_0 ~ ADC_CH_30
 ** \return  none
 ** \note	
*****************************************************************************/
void ADC_ClearChannelIntFlag(uint32_t Channel);

/*****************************************************************************
 ** \brief	ADC_EnableEPWMCmp0TriggerDelayTime
 **			ʹ  EPWM Ƚ0 ADC ʱ
 ** \param [in] none
 ** \return  none
 ** \note  
*****************************************************************************/
void ADC_EnableEPWMCmp0TriggerDelayTime(void);
/*****************************************************************************
 ** \brief	ADC_DisableEPWMCmp0TriggerDelayTime
 **			ر EPWM Ƚ0 ADC ʱ
 ** \param [in] none
 ** \return  none
 ** \note  
*****************************************************************************/
void ADC_DisableEPWMCmp0TriggerDelayTime(void);
/*****************************************************************************
 ** \brief	ADC_EnableEPWMCmp1TriggerDelayTime
 **			ʹ  EPWM Ƚ1 ADC ʱ
 ** \param [in] none
 ** \return  none
 ** \note  
*****************************************************************************/
void ADC_EnableEPWMCmp1TriggerDelayTime(void);
/*****************************************************************************
 ** \brief	ADC_DisableEPWMCmp1TriggerDelayTime
 **			ر EPWM Ƚ1 ADC ʱ
 ** \param [in] none
 ** \return  none
 ** \note  
*****************************************************************************/
void ADC_DisableEPWMCmp1TriggerDelayTime(void);

#ifdef __cplusplus
}
#endif

#endif /* __ADC_H_ */

