/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file demo_ccp.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "demo_ccp.h"

/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/


/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/
/*****************************************************************************
 ** \brief	CCP_Capture_Mode0_Config
 **			
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void CCP_Capture_Mode0_Config(void)
{
	/*
	(1)CCPʱ
	*/
	CGC_PER11PeriphClockCmd(CGC_PER11Periph_CCP,ENABLE);				/*CCPģʱ*/
	CCP_ConfigCLK(CCP0,CCP_CLK_DIV_64,CCP_RELOAD_CCPLOAD,4800);			/*Fccp = 48Mhz /64 = 0.75Mh -> = 4800/0.75Mhz = 6400us*/
																		/*CCP0ģֵΪ4800*/
	/*
	(2)CCPģʽ
	*/
	CCP_EnableCAPMode0(CCP0);											/*CCP0ĹģʽΪģʽ0*/
	CCP_ConfigCAPMode0(CCP0,CCP_CAP_MODE0_RISING_TO_FALLING);			/*CCP0Ĳģʽ0 ĲʽΪص½(ߵƽʱ)*/
																		/*/½زCCPģʹ(CCPRUN =1)󣬼ֵ4800(ֵ)¼ֹͣ浱ǰļֵ*/
													/*½زCCPģʹ(CCPRUN =1)󣬵ʱֵ4800(ֵ)¼(½)ֹͣ浱ǰļֵ*/
													/*½زCCPģʹ(CCPRUN =1)󣬵½ʱֵ4800(ֵ)¼()ֹͣ浱ǰļֵ*/
	/*
	(3)CCPͨ
	*/
	CCP_SelCAPMode0Channel(CCP0,CCPxA);									/*òͨΪCCPA0*/
	GPIO_PinAFInConfig(CCP0AINCFG, IO_INCFG_P04_CCP0A_I);				/*P04ΪCCPA0ͨ*/

	GPIO_Init(PORT0,PIN4,INPUT);
	/*
	(4)CCPж
	*/	
	CCP_EnableOverflowInt(CCP0);					/*CCP0ģж*/
	CCP_EnableCAPMode0Int(CCP0);				    /*CCP0ģ鲶ģʽ0ж*/
	NVIC_EnableIRQ(CCP_IRQn);		
	/*
	(5)CCP жȼ
	*/	
	NVIC_SetPriority(CCP_IRQn,3);					/*ȼ0~3 0ߡ3*/		
	/*
	(6)CCPģ
	*/	
	CCP_EnableRun(CCP0);			
	CCP_Start(CCP0);			/*CCP0ģʹ*/			
	
}

/*****************************************************************************
 ** \brief	CCP_Capture_Mode2_Config
 **			
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void CCP_Capture_Mode2_Config(void)
{
	/*
	(1)CCPʱ
	*/
	CGC_PER11PeriphClockCmd(CGC_PER11Periph_CCP,ENABLE);						/*CCPģʱ*/
	CCP_ConfigCLK(CCP1,CCP_CLK_DIV_64,CCP_RELOAD_CCPLOAD,48000);			/*Fccp = 16Mhz /64 = 0.25Mh -> = CAP0DATA/0.25Mhz*/
																																	/*CCP1ģֵΪ480000(ֵôֹ)Ȼ¼*/
	/*
	(2)CCPģʽ
	*/
	CCP_EnableCAPMode2();																						/*CCP1ĹģʽΪģʽ2*/
	CCP_ConfigCAPMode2(CAP1, CCP_CAP_MODE2_RISING);									/*CCP1 CAP1ĴΪشɼʼ*/
	CCP_ConfigCAPMode2(CAP2, CCP_CAP_MODE2_FALLING);								/*CCP1 CAP2ĴΪ½شɼһ*/
	CCP_ConfigCAPMode2(CAP3, CCP_CAP_MODE2_RISING);									/*CCP1 CAP3ĴΪشɼڶ*/

	/*
	(3)CCPͨ
	*/
	CCP_SelCAPMode2Channel(CAP1_CCP0B);									/*òͨΪCCP0B*/
	GPIO_PinAFInConfig(CCP0BINCFG, IO_INCFG_P26_CCP0B_I);				/*P26ΪCCP0Bͨ*/

	GPIO_Init(PORT2,PIN6,INPUT);
	/*
	(4)CCPж
	*/	
	CCP_EnableOverflowInt(CCP1);					/*CCP1ģж*/
//	CCP_EnableCAPMode2Int(CAP3);				    /*CCP1ģ鲶ģʽж*/

	NVIC_EnableIRQ(CCP_IRQn);		
	/*
	(5)CCP жȼ
	*/	
	NVIC_SetPriority(CCP_IRQn,3);					/*ȼ0~3 0ߡ3*/		
	/*
	(6)CCPģ
	*/	
	CCP_EnableRun(CCP1);			
	CCP_Start(CCP1);			/*CCP1ģʹ*/			
	CCP_EnableCAPMode2Int(CAP3);				    /*CCP1ģ鲶ģʽж*/
}



