/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : CMS32M6510
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/8/24
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "common.h"
#include "demo_crc.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
uint8_t CrcDataTab[16] = {0};
uint16_t CrcResult;
volatile uint32_t g_ticks;
void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks);
}



int main()
{
	uint32_t msCnt; 	// count value of 1ms
  uint32_t i; 
//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------
	g_ticks = 1000; 	// 1000ms
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 

	for(i=0;i<16;i++)
	{
		CrcDataTab[i]= i;
	}
	
	CrcResult = CRC_16_CCITT(CrcDataTab,16);
	
	while (1)
	{

		delayMS(2);


	}
}

/***********************************************************************************************************************
* Function Name: SysTick Handler
* Description  : Decreament the g_ticks value
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void SysTick_Handler(void)
{
	g_ticks--;
}


